-- Fun Server Script by DarkLight --
-- Credits to: Factis699 for using his script as model, Vain for the bounty hunter idea, ketamire for making tlex and me DarkLight lol. --
-- Note: It's recomended to use this script with tlex. --

FS = {}

-- Configuration --

FS.Randomizing = 0     -- Grade of randomizing that rounds have. 0 for minimal randomnizing, 1 for increazed randomizing and 2 for completely random. --
FS.Current_Rounds = 0  -- Shows a hud with the current round name when set on 0, or also with the next round name when set to 1. --
FS.HudID = 38          -- This is the id the hud text will use, chose values over 4 or you will get errors. --
FS.Interface_Color = "000190120" -- Sets the script interface color. --
FS.Drop_Weapons = 2    -- Sets if the players wont drop their weapons (0), drop only when pressing "G" (1), only when killed (2) or both presing "G" and dieing (3). --
FS.Bounty_Hunter = 1   --[[ Activates(1)/inactivates(0) the bounty hunter. When active, a player will be chosen at random to be the 
						    bounty. This player will give more score when killed. ]]--
FS.Bounty_Score = 3    -- Amount of score a player being the bounty gives when killed. --
FS.Bounty_Image = 1    -- Activates(1)/inactivates(0) the bounty image. This image will be drawn under the player being the bounty. --
FS.Bounty_Wait = 240  --[[ Waiting time (in seconds) for the bounty to be killed. After this time passes, the player being the bounty 
							gets the score, and another bounty is chosen after the same amount of time. ]]--
FS.Bounty_Players = 2  -- Number of alive players (not bots) needed to choose a bounty. If this requeriment isnt meet, the waiting time resets. --
FS.Tlex_Rank = 5       -- Set the rank which a player can use the say commands of this script on tlex ( 5 = admin by default). --
FS.Admin_List = {}     -- Admin list, use this if you are not using tlex. Put the admins usgn id here separated by coma (,). --

--[[ Commands --
	Tlex :
	* @setround: let you choose the next round.
	* @bounty: activates/inactivates the bounty hunter.
	Non-Tlex :
	* Server Action 1(F2): let you choose the next round.
]]--

-- Basic Functions --

function nonbots()
	local tab = {}
	for k,v in pairs(player(0,"tableliving")) do
		if not player(v,"bot") then
			table.insert(tab,v)
		end
	end
	return tab
end

-- Variables --

FS.Rounds = {}
FS.Round_Data = {[3] = 0}
FS.Bounty = {0,FS.Bounty_Wait,0}

-- Funtions --

dofile("sys/lua/FS_Rounds.lua")

if not v_TLex_path then
	addhook("serveraction","FS.Serveraction")
	addhook("buy","FS.Buy")
	local tab = {}
	for k,v in pairs(FS.Admin_List) do
		tab[tostring(v)] = true
	end
	FS.Admin_List = tab
else
	v_nobuy = true
	t_commands["setround"] = {"@","setround",FS.Tlex_Rank,5,0,0,"FS.Round_Menu(me,1)","@setround",1}
	t_commands["bounty"] = {"@","bounty",FS.Tlex_Rank,5,0,0,"if FS.Bounty_Hunter == 1 or FS.Bounty_Hunter == 2 then FS.Bounty_Hunter = 0 msg(FS.Interface_Color..' The bounty hunter has been disabled') elseif FS.Bounty_Hunter == 0 or FS.Bounty_Hunter == -1 then FS.Bounty_Hunter = 1 msg(FS.Interface_Color..' The bounty hunter has been enabled') end","@bounty",1}
end

function FS.Bounty_Img()
	if FS.Bounty_Image == 1 and FS.Bounty[1] ~= 0 then
		freeimage(FS.Bounty[3])
		FS.Bounty[3] = image("gfx/FS_GFX/Bounty.png",0,1,100+FS.Bounty[1])
		if player(FS.Bounty[1],"team") == 1 then
			imagecolor(FS.Bounty[3],255,000,000)
		elseif player(FS.Bounty[1],"team") == 2 then
			imagecolor(FS.Bounty[3],000,000,255)
		end
		imageblend(FS.Bounty[3],1)
		tween_rotateconstantly(FS.Bounty[3],5)
		imagescale(FS.Bounty[3],1.5,1.5)
	end
end

function FS.Round_Menu(id,page)
	local pagr = ((page-1)*7)+8
	if page == 1 then
		local pag = {}
		for bt = 1,8 do
			table.insert(pag,FS.Rounds[bt].Name)
		end
		menu(id,"Set Round Menu Page "..page..", "..table.concat(pag,", ")..", Next Page ===>")
	else
		local pag = {}
		for bt = pagr-6,pagr do
			if FS.Rounds[bt] ~= nil then
				table.insert(pag,FS.Rounds[bt].Name)
			end
		end
		local ttround = math.ceil(((#FS.Rounds-8)/7)+1)
		if page < ttround then
			menu(id,"Set Round Menu Page "..page..", <=== Previous Page, "..table.concat(pag,", ")..", Next Page ===>")
		else
			menu(id,"Set Round Menu Page "..page..", <=== Previous Page, "..table.concat(pag,", "))
		end
	end
end

-- Hooks --

addhook("ms100","FS.Ms100")
addhook("endround","FS.Endround")
addhook("startround","FS.Startround")
addhook("spawn","FS.Spawn",-2)
addhook("drop","FS.Drop")
addhook("die","FS.Die")
addhook("second","FS.Second")
addhook("leave","FS.Leave")
addhook("menu","FS.Menu")
addhook("join","FS.Join")

-- Hook Functions --

function FS.Buy(id,weapon)
	return 1
end

function FS.Ms100()
	if FS.Round_Data[3] == 0 and FS.Round_Data[1].Infinite_Ammo ~= nil then
		for _,id in pairs(player(0,"tableliving")) do
			for _,it in pairs(FS.Round_Data[1].Infinite_Ammo) do
				parse("equip "..id.." "..it)
			end
		end
	end
end

function FS.Endround()
	FS.Round_Data = {FS.Round_Data[2] or FS.Rounds[math.random(1,#FS.Rounds)],FS.Rounds[math.random(1,#FS.Rounds)],1}
	if FS.Randomizing > 0 then
		local chan = math.random(1,(-2*FS.Randomizing)+5)
		if chan == 3 then
			FS.Round_Data[2] = {Name = "Random",CTS = FS.Round_Data[2].CTS,TS = FS.Round_Data[2].TS}
		end
	end
	if FS.Round_Data[1].Name == "Random" then
		FS.Round_Data[1].Items = {}
		for ni = 1,math.random(1,5) do
			repeat FS.Round_Data[1].Items[ni] = math.random(1,88)
			until itemtype(FS.Round_Data[1].Items[ni],"dmg") > 0 or FS.Round_Data[1].Items == 88
		end
		FS.Round_Data[1].Armor = math.random(200,206)
		FS.Round_Data[1].Speedmod = math.random(-10,50)
		FS.Round_Data[1].Infinite_Ammo = FS.Round_Data[1].Items
		FS.Round_Data[1].Health = math.random(1,200)
	end
end

FS.Endround()

function FS.Startround()
	math.randomseed(os.time())
	FS.Round_Data[3] = 0
	msg(FS.Interface_Color..FS.Round_Data[1].Name..' Round!@C')
	parse('hudtxt '..(FS.HudID-3)..' ""')
	if FS.Round_Data[1].Floor then
		for _,it in pairs(FS.Round_Data[1].Floor) do
			parse("spawnitem "..it[1].." "..it[2].." "..it[3])
		end
	end
	parse('hudtxt '..(FS.HudID-2)..' "'..FS.Interface_Color..'Current Round: '..FS.Round_Data[1].Name..'" 320 20 1')
	if FS.Current_Rounds == 1 then
		parse('hudtxt '..(FS.HudID-3)..' "'..FS.Interface_Color..'Next Round: '..FS.Round_Data[2].Name..'" 320 420 1')
	end
	timer(1,"FS.Bounty_Img")
end

FS.Startround()

function FS.Spawn(id)
	parse("strip "..id.." 0")
	parse("setarmor "..id.." 0")
	parse("speedmod "..id.." 0")
	parse("setmaxhealth "..id.." 100")
	if FS.Round_Data[1].Items then
		for k, v in pairs(FS.Round_Data[1].Items) do
			parse("equip "..id.." "..v)
		end
		if FS.Round_Data[1].Set_Weapon then
			timer(10,"parse","setweapon "..id.." "..FS.Round_Data[1].Set_Weapon)
		end
	end
	if FS.Round_Data[1].No_Knife == 1 then
		timer(100,"parse","strip "..id.." 50")
	end
	if FS.Round_Data[1].Armor then
		parse("setarmor "..id.." "..FS.Round_Data[1].Armor)
	end
	if FS.Round_Data[1].Speedmod then
		parse("speedmod "..id.." "..FS.Round_Data[1].Speedmod)
	end
	if FS.Round_Data[1].Health then
		parse("setmaxhealth "..id.." "..FS.Round_Data[1].Health)
	end
	if FS.Round_Data[1].TS then
		if player(id,"team") == 1 then
			local pos = math.random(1,#FS.Round_Data[1].TS)
			parse("setpos "..id.." "..((FS.Round_Data[1].TS[pos][1]*32)+16).." "..(FS.Round_Data[1].TS[pos][2]*32)+16)
		end
	end
	if FS.Round_Data[1].CTS then
		if player(id,"team") == 2 then
			local pos = math.random(1,#FS.Round_Data[1].CTS)
			parse("setpos "..id.." "..((FS.Round_Data[1].CTS[pos][1]*32)+16).." "..(FS.Round_Data[1].CTS[pos][2]*32)+16)
		end
	end
end

function FS.Drop(id)
	if FS.Drop_Weapons == 0 then
		return 1
	elseif FS.Drop_Weapons == 2 and player(id,"health") > 1 then
		return 1
	end
end

function FS.Die(id,ki)
	if id == FS.Bounty[1] then
		if ki ~= 0 or id == ki then
			parse("setscore "..ki.." "..player(ki,"score")+(FS.Bounty_Score-1))
			msg(FS.Interface_Color..player(ki,"name").." killed the bounty!.")
			msg2(ki,FS.Interface_Color.."You won "..FS.Bounty_Score.." from killing the bounty!.")
			freeimage(FS.Bounty[3])
			FS.Bounty = {0,FS.Bounty_Wait,0}
		else
			msg(FS.Interface_Color.."The bounty died!.")
			freeimage(FS.Bounty[3])
			FS.Bounty = {0,math.random(1,FS.Bounty_Wait),0}
		end
		parse('hudtxt '..(FS.HudID-1)..' ""')
	end
	if FS.Drop_Weapons == 1 then
		return 1
	end
end

function FS.Second()
	if FS.Bounty_Hunter == 0 then
		freeimage(FS.Bounty[3])
		parse('hudtxt '..(FS.HudID-1)..' ""')
		parse('hudtxt '..FS.HudID..' ""')
		FS.Bounty = {0,FS.Bounty_Wait,0}
		FS.Bounty_Hunter = -1
	elseif FS.Bounty_Hunter == 1 then
		FS.Bounty = {0,math.random(1,FS.Bounty_Wait),0}
		FS.Bounty_Hunter = 2
	elseif FS.Bounty_Hunter == 2 then
		if FS.Bounty[2] == 0 then
			if FS.Bounty[1] == 0 then
				local tb = nonbots()
				if #tb > FS.Bounty_Players then
					FS.Bounty = {tb[math.random(1,#tb)],FS.Bounty_Wait,0}
					FS.Bounty_Img()
					msg(FS.Interface_Color..player(FS.Bounty[1],"name").." its the bounty!.")
				else
					msg(FS.Interface_Color.."There are not enough non-bot players to chose a bounty.")
					FS.Bounty[2] = FS.Bounty_Wait
				end
			else
				msg(FS.Interface_Color..player(FS.Bounty[1],"name").." dint get killed and won "..FS.Bounty_Score.." Score!.")
				parse('hudtxt '..(FS.HudID-1)..' ""')
				parse("setscore "..FS.Bounty[1].." "..FS.Bounty_Score)
				freeimage(FS.Bounty[3])
				FS.Bounty = {0,FS.Bounty_Wait,0}
			end
		elseif FS.Bounty[2] > 0 then
			parse('hudtxt '..FS.HudID..' "'..FS.Interface_Color..'Bounty: Chosen in '..math.ceil(FS.Bounty[2]/60)..' min." 10 200')
			if FS.Bounty[1] == 0 and (FS.Bounty[2]%60) == 0 then
				msg(FS.Interface_Color.."The next bounty will be chosen in "..(FS.Bounty[2]/60).." minutes!.")
			elseif FS.Bounty[1] ~= 0 then
				local mi,sec = math.floor(FS.Bounty[2]/60),FS.Bounty[2]%60
				parse('hudtxt '..FS.HudID..' "'..FS.Interface_Color..'Bounty: '..player(FS.Bounty[1],"name")..'" 10 200')
				if sec > 9 then
					parse('hudtxt '..(FS.HudID-1)..' "'..FS.Interface_Color..'Time Left: '..mi..':'..sec..' min." 10 216')
				else
					parse('hudtxt '..(FS.HudID-1)..' "'..FS.Interface_Color..'Time Left: '..mi..':0'..sec..' min." 10 216')
				end
			end
			FS.Bounty[2] =  FS.Bounty[2]-1
		end
	end
end

function FS.Leave(id,reason)
	if id == FS.Bounty[1] then
		local reasons = {"left","got kicked","got banned","lagged too much"}
		msg(FS.Interface_Color.."The bounty "..reasons[reason+1].."!.")
		freeimage(FS.Bounty[3])
		FS.Bounty = {0,math.random(1,FS.Bounty_Wait),0}
	end
end

function FS.Menu(id,title,button)
	if title == "Restart Round?" then
		if button == 1 then
			parse("restart")
		end
	end
	local ttround = math.ceil(((#FS.Rounds-8)/7)+1)
	for pg = 1,ttround do
		if title == "Set Round Menu Page "..pg then
			if pg == 1 then
				for bt = 1,8 do
					if bt == button then
						FS.Round_Data[2] = FS.Rounds[bt]
						msg(FS.Interface_Color.."Next round set, it will be "..FS.Round_Data[2].Name.."!@C")
						parse('hudtxt '..(FS.HudID-3)..' "'..FS.Interface_Color..'Next Round: '..FS.Round_Data[2].Name..'" 320 420 1')
						menu(id,"Restart Round?, HELL YEAH!, FUCK NO!")
					end
				end
				if button == 9 then
					FS.Round_Menu(id,2)
				end
			elseif pg > 1 then
				if button == 1 then
					FS.Round_Menu(id,pg-1)
				end
				for bt = 2,8 do
					if bt == button then
						FS.Round_Data[2] = FS.Rounds[((pg-2)*7)+8+(bt-1)]
						msg(FS.Interface_Color.."Next round set, it will be "..FS.Round_Data[2].Name.."!@C")
						parse('hudtxt '..(FS.HudID-3)..' "'..FS.Interface_Color..'Next Round: '..FS.Round_Data[2].Name..'" 320 420 1')
						menu(id,"Restart Round?, HELL YEAH!, FUCK NO!")
					end
				end
				if button == 9 and pg+1 <= math.ceil(((#FS.Rounds-8)/7)+1) then
					FS.Round_Menu(id,pg+1)
				end
			end
		end
	end
end

function FS.Serveraction(id,action)
	if FS.Admin_List[""..player(id,"usgn")] and action == 1 then
		FS.Round_Menu(id,1)
	end
end

function FS.Join(id)
	tween_rotateconstantly(FS.Bounty[3],5)
end